﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ConsoleApplication1
{
    class Point3D : Point
    {
        protected int z;
        public int Z // property
        {
            get { return z; }
            set { z = value; }
        }
        // ctor
        public Point3D(): this(10, 10, 10) { }
        public Point3D(int x, int y, int z) : base(x, y)
        {
            this.z = z;
        }

        // method
        public void SetPosition(int x, int y, int z)
        {
            base.SetPosition(x, y);
            this.z = z;
        }

        public void Move(int x, int y, int z)
        {
            base.Move(x, y);
            this.z += z;
        }

        public void Move(Point3D other)
        {
            this.x += other.X;
            this.y += other.Y;
            this.z += other.Z;
        }

        public override void Move(Point other)
        {
            if (other is Point3D)
                Move((Point3D)other);
            else
                base.Move(other);
        }

        public override string ToString()
        {
            return String.Format("({0}, {1}, {2})", x, y, z);
        }

        public override void Print()
        {
            Console.WriteLine("({0}, {1}, {2})", x, y, z);
        }
    }
}
