﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ConsoleApplication1
{
    class Base 
    {
        public virtual void Print() { Console.WriteLine("Base Print"); }
    }

    class Derived : Base
    {
        public override void Print() { Console.WriteLine("Derived Print"); }
    }

    class Program
    {
        static void Main(string[] args)
        {
            Base b = new Base();
            b.Print();
            Derived d = new Derived();
            d.Print();
            Base c = d;
            c.Print();

            Point p1 = new Point(5, 5);
            p1.Print();
            Point p2 = new Point(10, 10);
            Console.WriteLine(p2.ToString());
            p1.Move(p2);
            p1.Print(); // (15, 15)

            Console.WriteLine();
            Point3D p3 = new Point3D(1, 1, 1);
            Point3D p4 = new Point3D(2, 2, 2);
            p3.Move(p4);
            p3.Print(); // (3, 3, 3)

            Point p = p3;
            p.Print(); // late binding
            p.Move(p4); // 
            p.Print(); // (5, 5, 5)


            /*
            p3.SetPosition(10, 10);
            p3.Print();
            p3.SetPosition(100, 100, 100);
            p3.Print(); // (100, 100, 100)
            p3.Move(10, 10);
            p3.Print(); // (110, 110, 100)
            p3.Move(100, 100, 100);
            p3.Print(); // (210, 210, 200)
            */
            //Point p4 = p3; // upcasting
            //p4.Print();
        }
    }
}
